package uy.edu.fing.tse.jsf;

import uy.edu.fing.tse.central.business.BusinessLocal;
import uy.edu.fing.tse.dto.Role;
import uy.edu.fing.tse.dto.User;
import uy.edu.fing.tse.dto.UserBO;
import uy.edu.fing.tse.dto.UserFO;

import javax.annotation.PostConstruct;
import javax.ejb.EJB;
import javax.enterprise.context.RequestScoped;
import javax.inject.Named;
import java.io.Serializable;
import java.util.List;

@RequestScoped
@Named("gestionUsuarios")
public class GestionUsuariosBean implements Serializable {

    private static final long serialVersionUID = 9142442208455999158L;

    @EJB
    private BusinessLocal service;

    @PostConstruct
    public void init() {
        usuarios = service.listarUsuarios();
        roles = service.listarRoles();
    }

    private List<User> usuarios;
    private List<User> usuariosFilter;

    private List<Role> roles;

    public List<User> getUsuarios() {
        return usuarios;
    }

    public void setUsuarios(List<User> usuarios) {
        this.usuarios = usuarios;
    }

    public List<Role> getRoles() {
        return roles;
    }

    public void setRoles(List<Role> roles) {
        this.roles = roles;
    }

    public List<User> getUsuariosFilter() {
        return usuariosFilter;
    }

    public void setUsuariosFilter(List<User> usuariosFilter) {
        this.usuariosFilter = usuariosFilter;
    }

    public boolean isBO(User u) {
        return u instanceof UserBO;
    }

    public boolean isFO(User u) {
        return u instanceof UserFO;
    }

    public String getRole(User u) {
        return ((UserBO) u).getRole().getName();
    }
}

