package uy.edu.fing.tse.jsf.security;

import io.jsonwebtoken.Claims;
import io.jsonwebtoken.Jwts;

import javax.servlet.*;
import javax.servlet.annotation.WebFilter;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

@WebFilter("/jsf/*")
public class JwtFilter implements javax.servlet.Filter {

    @Override
    public void init(FilterConfig filterConfig) throws ServletException {
    }

    @Override
    public void doFilter(ServletRequest req, ServletResponse res, FilterChain chain) throws IOException, ServletException {
        final HttpServletRequest request = (HttpServletRequest) req;
        final HttpServletResponse response = (HttpServletResponse) res;

        Cookie cookieToken = findTokenCookie(request);

        if (cookieToken == null || cookieToken.getValue() == null) {
            response.setStatus(401);
            response.sendRedirect(request.getContextPath() + "/login.xhtml");
            return;
        }

        final var token = cookieToken.getValue();

        try {
            final Claims claims = Jwts.parser().setSigningKey("1q2w3e4r5t6y7u8i9o0p").parseClaimsJws(token).getBody();
            request.setAttribute("claims", claims);
            final var session = request.getSession();
            session.setAttribute("token", token);
            session.setAttribute("role", claims.get("role"));
            session.setAttribute("user", claims.getSubject());
        } catch (final Exception e) {
            response.setStatus(401);
            response.sendRedirect(request.getContextPath() + "/login.xhtml");
            return;
        }

        chain.doFilter(req, res);
    }

    static Cookie findTokenCookie(final HttpServletRequest request) {
        Cookie cookieToken = null;
        final var cookies = request.getCookies();
        if (cookies != null) {
            for (Cookie cookie : cookies) {
                if ("token".equals(cookie.getName())) {
                    cookieToken = cookie;
                    break;
                }
            }
        }
        return cookieToken;
    }

    @Override
    public void destroy() {
    }
}
