package uy.edu.fing.tse.jsf.security;

import io.jsonwebtoken.Claims;
import io.jsonwebtoken.Jwts;

import javax.servlet.*;
import javax.servlet.annotation.WebFilter;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

import static uy.edu.fing.tse.jsf.security.JwtFilter.findTokenCookie;

@WebFilter("/login.xhtml")
public class LoginFilter implements Filter {

    @Override
    public void init(FilterConfig filterConfig) throws ServletException {
    }

    @Override
    public void doFilter(ServletRequest req, ServletResponse res, FilterChain chain) throws IOException, ServletException {
        final HttpServletRequest request = (HttpServletRequest) req;
        final HttpServletResponse response = (HttpServletResponse) res;

        Cookie cookieToken = findTokenCookie(request);

        if (cookieToken == null || cookieToken.getValue() == null) {
            chain.doFilter(req, res);
            return;
        }

        final var token = cookieToken.getValue();

        try {
            final Claims claims = Jwts.parser().setSigningKey("1q2w3e4r5t6y7u8i9o0p").parseClaimsJws(token).getBody();
            response.sendRedirect(request.getContextPath() + "/jsf/listarHechos.xhtml");
        } catch (final Exception e) {
            chain.doFilter(req, res);
            return;
        }

        chain.doFilter(req, res);
    }

    @Override
    public void destroy() {
    }
}
