package uy.edu.fing.tse.central.db.dao.check.checker;

import uy.edu.fing.tse.central.db.entity.VerificacionChecker;
import uy.edu.fing.tse.central.db.mapper.MyMapper;
import uy.edu.fing.tse.dto.CheckChecker;

import javax.annotation.PostConstruct;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import java.util.List;
import java.util.stream.Collectors;

@Stateless
public class CheckCheckerDAOBean implements CheckCheckerDaoLocal {

    @PersistenceContext(unitName = "central")
    private EntityManager em;

    @PostConstruct
    void init() {
        //Despues del constructor hace esto
    }

    @Override
    public CheckChecker create(CheckChecker elem) {
        final var r = MyMapper.INSTANCE.convert(elem);
        em.persist(r);
        em.flush();
        return MyMapper.INSTANCE.convert(r);
    }

    @Override
    public CheckChecker update(CheckChecker elem) {
        final var r = MyMapper.INSTANCE.convert(elem);
        final var then = em.merge(r);
        em.flush();
        return MyMapper.INSTANCE.convert(then);
    }

    @Override
    public void remove(CheckChecker elem) {
        final var r = em.find(VerificacionChecker.class, elem.getId());
        em.remove(r);
    }

    @Override
    public CheckChecker find(String key) {
        final var query = em.createNamedQuery("VerificacionChecker.findByFact", VerificacionChecker.class);
        query.setParameter("idFact", Long.parseLong(key));
        final var r = query.getSingleResult();
        return MyMapper.INSTANCE.convert(r);
    }

    @Override
    public CheckChecker find(Long id) {
        final var r = em.find(VerificacionChecker.class, id);
        return MyMapper.INSTANCE.convert(r);
    }

    @Override
    public List<CheckChecker> findAll() {
        final var query = em.createNamedQuery("VerificacionChecker.findAll", VerificacionChecker.class);
        final List<VerificacionChecker> r = query.getResultList();
        return r.stream().map(MyMapper.INSTANCE::convert).collect(Collectors.toList());
    }
}
