package uy.edu.fing.tse.central.db.dao.check.mechanism;

import uy.edu.fing.tse.central.db.entity.VerificacionMecanismo;
import uy.edu.fing.tse.central.db.mapper.MyMapper;
import uy.edu.fing.tse.dto.CheckMechanism;

import javax.annotation.PostConstruct;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import java.util.List;
import java.util.stream.Collectors;

@Stateless
public class CheckMechanismDAOBean implements CheckMechanismDaoLocal {

    @PersistenceContext(unitName = "central")
    private EntityManager em;

    @PostConstruct
    void init() {
        //Despues del constructor hace esto
    }

    @Override
    public CheckMechanism create(CheckMechanism elem) {
        final var r = MyMapper.INSTANCE.convert(elem);
        em.persist(r);
        em.flush();
        return MyMapper.INSTANCE.convert(r);
    }

    @Override
    public CheckMechanism update(CheckMechanism elem) {
        final var r = MyMapper.INSTANCE.convert(elem);
        final var then = em.merge(r);
        em.flush();
        return MyMapper.INSTANCE.convert(then);
    }

    @Override
    public void remove(CheckMechanism elem) {
        final var r = em.find(VerificacionMecanismo.class, elem.getId());
        em.remove(r);
    }

    @Override
    public CheckMechanism find(String key) {
        final var query = em.createNamedQuery("VerificacionMecanismo.findByFact", VerificacionMecanismo.class);
        query.setParameter("idFact", Long.parseLong(key));
        final var r = query.getSingleResult();
        return MyMapper.INSTANCE.convert(r);
    }

    @Override
    public CheckMechanism find(Long id) {
        final var r = em.find(VerificacionMecanismo.class, id);
        return MyMapper.INSTANCE.convert(r);
    }

    @Override
    public List<CheckMechanism> findAll() {
        final var query = em.createNamedQuery("VerificacionMecanismo.findAll", VerificacionMecanismo.class);
        final List<VerificacionMecanismo> r = query.getResultList();
        return r.stream().map(MyMapper.INSTANCE::convert).collect(Collectors.toList());
    }
}
