package uy.edu.fing.tse.central.db.dao.mechanism;

import uy.edu.fing.tse.central.db.entity.Mecanismo;
import uy.edu.fing.tse.central.db.mapper.MyMapper;
import uy.edu.fing.tse.dto.Mechanism;

import javax.annotation.PostConstruct;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import java.util.List;
import java.util.stream.Collectors;

@Stateless
public class MechanismDAOBean implements MechanismDaoLocal {

    @PersistenceContext(unitName = "central")
    private EntityManager em;

    @PostConstruct
    void init() {
        //Despues del constructor hace esto
    }

    @Override
    public Mechanism create(Mechanism elem) {
        final var r = MyMapper.INSTANCE.convert(elem);
        em.persist(r);
        em.flush();
        return MyMapper.INSTANCE.convert(r);
    }

    @Override
    public Mechanism update(Mechanism elem) {
        final var r = MyMapper.INSTANCE.convert(elem);
        final var then = em.merge(r);
        em.flush();
        return MyMapper.INSTANCE.convert(then);
    }

    @Override
    public void remove(Mechanism elem) {
        final var r = em.find(Mecanismo.class, elem.getId());
        em.remove(r);
    }

    @Override
    public Mechanism find(String key) {
        final var query = em.createNamedQuery("Calificacion.findByName", Mecanismo.class);
        query.setParameter("name", key);
        final var r = query.getSingleResult();
        return MyMapper.INSTANCE.convert(r);
    }

    @Override
    public Mechanism find(Long id) {
        final var r = em.find(Mecanismo.class, id);
        return MyMapper.INSTANCE.convert(r);
    }

    @Override
    public List<Mechanism> findAll() {
        final var query = em.createNamedQuery("Calificacion.findAll", Mecanismo.class);
        final List<Mecanismo> r = query.getResultList();
        return r.stream().map(MyMapper.INSTANCE::convert).collect(Collectors.toList());
    }
}
