package uy.edu.fing.tse.central.db.dao.score;

import uy.edu.fing.tse.central.db.entity.Calificacion;
import uy.edu.fing.tse.central.db.mapper.MyMapper;
import uy.edu.fing.tse.dto.Score;

import javax.annotation.PostConstruct;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import java.util.List;
import java.util.stream.Collectors;

@Stateless
public class ScoreDAOBean implements ScoreDaoLocal {

    @PersistenceContext(unitName = "central")
    private EntityManager em;

    @PostConstruct
    void init() {
        //Despues del constructor hace esto
    }

    @Override
    public Score create(Score elem) {
        final var r = MyMapper.INSTANCE.convert(elem);
        em.persist(r);
        em.flush();
        return MyMapper.INSTANCE.convert(r);
    }

    @Override
    public Score update(Score elem) {
        final var r = MyMapper.INSTANCE.convert(elem);
        final var then = em.merge(r);
        em.flush();
        return MyMapper.INSTANCE.convert(then);
    }

    @Override
    public void remove(Score elem) {
        final var r = em.find(Calificacion.class, elem.getId());
        em.remove(r);
    }

    @Override
    public Score find(String key) {
        final var query = em.createNamedQuery("Calificacion.findByValue", Calificacion.class);
        query.setParameter("val", key);
        final var r = query.getSingleResult();
        return MyMapper.INSTANCE.convert(r);
    }

    @Override
    public Score find(Long id) {
        final var r = em.find(Calificacion.class, id);
        return MyMapper.INSTANCE.convert(r);
    }

    @Override
    public List<Score> findAll() {
        final var query = em.createNamedQuery("Calificacion.findAll", Calificacion.class);
        final List<Calificacion> r = query.getResultList();
        return r.stream().map(MyMapper.INSTANCE::convert).collect(Collectors.toList());
    }
}
