package uy.edu.fing.tse.central.db.dao.statehistory;

import uy.edu.fing.tse.central.db.entity.TransicionEstado;
import uy.edu.fing.tse.central.db.mapper.MyMapper;
import uy.edu.fing.tse.dto.StateHistory;

import javax.annotation.PostConstruct;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import java.util.List;
import java.util.stream.Collectors;

@Stateless
public class StateHistoryDAOBean implements StateHistoryDaoLocal {

    @PersistenceContext(unitName = "central")
    private EntityManager em;

    @PostConstruct
    void init() {
        //Despues del constructor hace esto
    }

    @Override
    public StateHistory create(StateHistory elem) {
        final var r = MyMapper.INSTANCE.convert(elem);
        em.persist(r);
        em.flush();
        return MyMapper.INSTANCE.convert(r);
    }

    @Override
    public StateHistory update(StateHistory elem) {
        final var r = MyMapper.INSTANCE.convert(elem);
        final var then = em.merge(r);
        em.flush();
        return MyMapper.INSTANCE.convert(then);
    }

    @Override
    public void remove(StateHistory elem) {
        final var r = em.find(TransicionEstado.class, elem.getId());
        em.remove(r);
    }

    @Override
    public StateHistory find(String key) {
        final var query = em.createNamedQuery("TransicionEstado.findByState", TransicionEstado.class);
        query.setParameter("val", key);
        final var r = query.getSingleResult();
        return MyMapper.INSTANCE.convert(r);
    }

    @Override
    public StateHistory find(Long id) {
        final var e = em.find(TransicionEstado.class, id);
        return MyMapper.INSTANCE.convert(e);
    }

    @Override
    public List<StateHistory> findAll() {
        final var query = em.createNamedQuery("TransicionEstado.findAll", TransicionEstado.class);
        final List<TransicionEstado> r = query.getResultList();
        return r.stream().map(MyMapper.INSTANCE::convert).collect(Collectors.toList());
    }
}
