package uy.edu.fing.tse.central.db.entity;

import javax.persistence.*;
import java.util.Date;

@Entity
@NamedQueries({
        @NamedQuery(name = "TransicionEstado.findAll", query = "select r from TransicionEstado r"),
        @NamedQuery(name = "TransicionEstado.findByState", query = "select r from TransicionEstado r inner join r.state as s where s.value = :val")
})
public class TransicionEstado {

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;

    @ManyToOne(optional = false, fetch = FetchType.EAGER)
    private Estado state;

    @ManyToOne(optional = false, fetch = FetchType.EAGER)
    private Usuario user;

    @ManyToOne(optional = false, fetch = FetchType.EAGER)
    private Hecho fact;

    @Column(nullable = false)
    private Date date = new Date();

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Estado getState() {
        return state;
    }

    public void setState(Estado state) {
        this.state = state;
    }

    public Usuario getUser() {
        return user;
    }

    public void setUser(Usuario user) {
        this.user = user;
    }

    public Hecho getFact() {
        return fact;
    }

    public void setFact(Hecho fact) {
        this.fact = fact;
    }

    public Date getDate() {
        return date;
    }

    public void setDate(Date date) {
        this.date = date;
    }
}
