package uy.edu.fing.tse.central.db.mapper;

import org.junit.Assert;
import org.junit.Test;
import uy.edu.fing.tse.central.db.entity.Periferico;
import uy.edu.fing.tse.dto.*;

public class MyMapperTest {

    @Test
    public void convert() {
        final var state1 = new State();
        state1.setValue("Nuevo");

        final var state2 = new State();
        state2.setValue("Viejo");

        final var category = new Category();
        category.setDescription("La categoria de las frutaas");
        category.setName("Frutero");

        final var score = new Score();
        score.setValue("Totalmente Falsa");

        final var role = new Role();
        role.setName("Checker");

        final var userFO = new UserFO();
        userFO.setMail("faller222@gmail.com");


        final var userBO = new UserBO();
        userBO.setMail("admin@gmail.com");
        userBO.setRole(role);

        final var sh1 = new StateHistory();
        sh1.setState(state1);
        sh1.setUser(userFO);

        final var sh2 = new StateHistory();
        sh2.setState(state2);
        sh2.setUser(userBO);

        final var fact = new Fact();
        fact.setTitle("soy un titulo");
        fact.setDescription("y esta descrip");
        fact.setActualState(state2);
        fact.setCategory(category);
        fact.setScore(score);
        fact.addHistory(sh1);
        fact.addHistory(sh2);

        final var convert = MyMapper.INSTANCE.convert(fact);
        Assert.assertNotNull(convert);
        final var convert2 = MyMapper.INSTANCE.convert(convert);
        Assert.assertNotNull(convert2);

        System.out.println("#######################################################\n" +
                "#######################################################\n" +
                "#######################################################\n");

    }

    @Test
    public void convert2() {
        final var periferico = new Periferico();
        periferico.setName("hola");

        final var convert = MyMapper.INSTANCE.convert(periferico);
        Assert.assertNotNull(convert);
        final var convert2 = MyMapper.INSTANCE.convert(convert);
        Assert.assertNotNull(convert2);
    }
}