package uy.edu.fing.tse.central.business.security;


import io.jsonwebtoken.Jwts;
import io.jsonwebtoken.SignatureAlgorithm;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import uy.edu.fing.tse.central.business.common.Secure;
import uy.edu.fing.tse.central.db.dao.role.RoleDaoLocal;
import uy.edu.fing.tse.central.db.dao.user.UserDaoLocal;
import uy.edu.fing.tse.dto.User;
import uy.edu.fing.tse.dto.UserBO;

import javax.annotation.PostConstruct;
import javax.ejb.EJB;
import javax.ejb.Stateless;
import java.util.Calendar;
import java.util.Date;
import java.util.Objects;

@Stateless
public class SecurityBean implements SecurityLocal, SecurityRemote {

    private static final Logger LOG = LoggerFactory.getLogger(Security.class);

    @EJB
    private UserDaoLocal users;
    @EJB
    private RoleDaoLocal roles;

    @PostConstruct
    void init() {
        //Despues Hace esto
    }

    @Override
    public User register(UserBO p) {
        final var salt = Secure.generateSalt();
        p.setSalt(salt);
        final var newPassword = Secure.encriptPBKDF(p.getPassword(), salt);
        p.setPassword(newPassword);

        final var role = roles.find(p.getRole().getName());
        p.setRole(role);
        return users.create(p);
    }

    @Override
    public String login(UserBO p) {
        //Valido la password
        final var user = (UserBO) users.find(p.getMail());
        final var salt = user.getSalt();
        final var thisPassword = Secure.encriptPBKDF(p.getPassword(), salt);

        if (Objects.equals(thisPassword, user.getPassword())) {
            return createJWT(user.getMail(), user.getRole().getName());
        }
        return null;
    }

    private String createJWT(String user, String role) {
        // prepare expiration date according to application properties
        Date expDate = new Date();
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(expDate);

        calendar.add(Calendar.MINUTE, 15);
        expDate = calendar.getTime();

        return Jwts.builder().setSubject(user).claim("role", role).setIssuedAt(new Date()).setExpiration(expDate)
                .signWith(SignatureAlgorithm.HS256, "1q2w3e4r5t6y7u8i9o0p").compact();
    }

}
